'use strict';

var pluginAuthNode = require('@backstage/plugin-auth-node');
var zod = require('zod');

exports.azureEasyAuthSignInResolvers = void 0;
((azureEasyAuthSignInResolvers2) => {
  azureEasyAuthSignInResolvers2.idMatchingUserEntityAnnotation = pluginAuthNode.createSignInResolverFactory({
    optionsSchema: zod.z.object({
      dangerouslyAllowSignInWithoutUserInCatalog: zod.z.boolean().optional()
    }).optional(),
    create(options = {}) {
      return async (info, ctx) => {
        const {
          fullProfile: { id }
        } = info.result;
        if (!id) {
          throw new Error("User profile contained no id");
        }
        return ctx.signInWithCatalogUser(
          {
            annotations: {
              "graph.microsoft.com/user-id": id
            }
          },
          {
            dangerousEntityRefFallback: options?.dangerouslyAllowSignInWithoutUserInCatalog ? { entityRef: { name: id } } : void 0
          }
        );
      };
    }
  });
})(exports.azureEasyAuthSignInResolvers || (exports.azureEasyAuthSignInResolvers = {}));
//# sourceMappingURL=resolvers.cjs.js.map
